// TeXworksScript
// Title: \cite from JabRef -> MySql
// Description: Make other Scripts
// Author: Paul A. Norman
// Version: 0.3
// Date: 2010-07-16
// Script-Type: standalone
// Context: TeXDocument
// Shortcut: Alt+B, Alt+C

function makeSpace(howMuch)
{

 var space = new String("");
 for (x = 0; x < howMuch +7; x++) // +7 as we are dealing on Win at least with a proportional font in dropdown
     {
		  space += " ";
		  }

return space;
}

var citationType = ["[1. page 2-3]", "Goossens et al. (1993)","(Goossens et al., 1993)","Goossens, Mittlebach, and Samarin (1993)","(Goossens, Mittlebach, and Samarin, 1993)", "Jones et al.","Jones, Baker, and Williams","1990","(1990)"];

var insertCite = [ "cite", "citet", "citep", "citet*", "citep*", "citeauthor", "citeauthor*", "citeyear", "citeyearpar"];

var citationOrder = ["By Citation Key","By Title", "By Author - (on first Name)", "Year", "Journal"];
var       orderBy = ["cite_key", "title", "author", "year", "journal"];

var reBuildDisplayText = [];

var phpScript = __FILE__.substr(0,__FILE__.lastIndexOf("/") +1) +  'getCiteKeys.php';

var chosenOrderBy = TW.getItem( null, "Order Citations", "Please Choose A Citation Order: ", citationOrder , 0, true ) ;  // first and third options probably mostly do the same - for completness

  for (i =0; i < citationOrder.length; i++)
	      {
				  if (chosenOrderBy == citationOrder[i])
				      {citeOrderNum = i;
							 break;
							 }
				 }

// Non-windows OSes won't need the cmd /c
   var citeKeysAndTitle = TW.app.system('cmd /c php ' + phpScript + ' ' + orderBy[citeOrderNum]).split("\n");
	 
	 var maxCiteKeyLength = 0;
	 
	 for (descript in citeKeysAndTitle) // add padding to move start point for title away from cite_key in drop down immediately below
	      {
				 test = citeKeysAndTitle[descript].indexOf(', ');
				 
				 maxCiteKeyLength = (test > maxCiteKeyLength) ? test : maxCiteKeyLength;

					 reBuildDisplayText.push(
                        			     [
																	   citeKeysAndTitle[descript].substr(0,test +1),
                                        citeKeysAndTitle[descript].substr(test +1)
																	 ]
									               );
				} 
				
				for (descript = 0;  descript < citeKeysAndTitle.length; descript++)
				{
				 citeKeysAndTitle[descript] = reBuildDisplayText[descript][0] 
				                                + makeSpace(maxCiteKeyLength - reBuildDisplayText[descript][0].length) 
																				+ reBuildDisplayText[descript][1] 
				 } 
	 

var chosenCitation = TW.getItem( null, "Insert Citation", "Please Choose A Citation Key: ", citeKeysAndTitle , 0, true ) ;

  if (chosenCitation != undefined)
  {

            var pageRange = TW.getText( null, "Page Range", "Please enter A Page Range etc.\n\nE.g.>  123-127\n\nOr Cancel for None - OK to fill out later", "");
            if (pageRange == undefined)
            {
              pageRange = "";
              }
            else
            {
              pageRange = '[P.~'+ pageRange + ']';
              }

          var citeTypeChosen = TW.getItem( null, "Citation Style", "(In Preamble, Place: \\usepackage{natbib})\n\n\nChoose A Citation Type: ",
                                  citationType , 0, true ) ;

        if (citeTypeChosen != undefined)
        {
            for (find =0; find < citationType.length; find++)
            {
             if (citationType[find] == citeTypeChosen)
             {
                     citeType = insertCite[find];
                     break;
                     }
              }
							
							chosenCitation = chosenCitation.substr(0, chosenCitation.indexOf(", "));
							
                     TW.target.insertText('\\'+citeType+pageRange+'{'+chosenCitation+'}');
										 TW.target.statusTip = 'In Preamble, Need to Place: \\usepackage{natbib} ?';
                     }// /End. IF  citeType != undefined
                          } // /End. IF chosenCitation != undefined
                                null;

   // Thanks to http://www.andy-roberts.net/misc/latex/latextutorial3.html
   // Thanks to http://www.ctan.org/tex-archive/macros/latex/contrib/natbib/natbib.pdf
   